--- ========================================================= ---
---  Setup Locals
--- ========================================================= ---
local L = LibStub("AceLocale-3.0"):GetLocale("DaHud", true)
local DaHud = LibStub("AceAddon-3.0"):GetAddon("DaHud")
local mod = DaHud:GetModule("Icons", true)

if not(mod) then return end

local localeTables = {}
function DaHud:L(name)
	if not localeTables[name] then
		localeTables[name] = setmetatable({}, {__index = function(self, key)
			self[key] = key
			return key
		end})
	end
	return localeTables[name]
end

local L = DaHud:L("DaHud")

--- ========================================================= ---
---  API
--- ========================================================= ---
DaHud.Icons.Plugins.resting = L["Resting"]

DaHud.Icons.Type.player.resting = L["Resting"]

DaHud.Icons.Elements.textures.resting = "Interface\\CharacterFrame\\UI-StateIcon"

--- ========================================================= ---
---  Register Frame Events
--- ========================================================= ---
function mod:RegisterFrameEvents_resting(id)
	if not(id) then return end

	local f = DaHud.Frames.Icons[id]
	
	local settings = DaHud.db.profile.icons[id]
	
	if (settings.type ~= "resting") then return end
	
	f:RegisterEvent("PLAYER_ENTERING_WORLD")
	f:RegisterEvent("PLAYER_UPDATE_RESTING")
end

--- ========================================================= ---
---  Set Config Mode
--- ========================================================= ---
function mod:SetConfigMode_resting(f)
	f.Icon:SetTexCoord(0.09, 0.43, 0.08, 0.42)
end

--- ========================================================= ---
---  Update Resting
--- ========================================================= ---
function mod:Update_resting(f)
	if not(f) then return end

	local id = string.gsub(f:GetName(), "DaHud_", "")
	local settings = DaHud.db.profile.icons[id]
	
	f.Icon:SetTexCoord(0.09, 0.43, 0.08, 0.42)
	
	if IsResting() then
		f:SetAlpha(1)
	else
		f:SetAlpha(0)
	end
end